*this page is a work in progress*
[return home](/)

# Portfolio

Hi, this is a non-exhaustive list of my personal projects. It appears I like making things with computers.
For my 3D art see [/blender](/blender) and photography at [/photos](/photos)

The dates listed are generally the last time any significant change was made, for projects that spanned several months.

## categories
- [hardware](#hardware)
- [game jam games](#jam-games)
- [shaders](#shaders)
- [raymarching shaders](#raymarching)
- [utilities](#utilities)
- [misc](#misc)

# hardware
### leko pona
`2022-08`
source: [https://git.crispypin.cc/CrispyPin/leko-pona](https://git.crispypin.cc/CrispyPin/leko-pona)
==image:"/media/leko_tonsi.png":"leko pona, a split keyboard with blank keycaps in the trans flag colours"
(The deskmat texture was created with my [julia fractal renderer](#julia-fractal-renderer))

## ch32v003 oled board
project files: [git.crispypin.cc/CrispyPin/ch32_oled](https://git.crispypin.cc/CrispyPin/ch32_oled)

### bad apple
`2024-04`
source: [git.crispypin.cc/CrispyPin/bad-apple](https://git.crispypin.cc/CrispyPin/bad-apple/)
==youtube:G0eonL14tCQ

### Conways Game of Life
`2024-04`
==video:"/media/ch32_gol.mp4":"conways game of life on a tiny display"

### Runner game
`2024-04`
==video:"/media/musi_pi_soweli_tawa.mp4":"simple runner game, similar to the chrome dino game"

## rotary encoder keyboard
`2022-05`
[github.com/CrispyPin/rotary-kb](https://github.com/CrispyPin/rotary-kb/)
A silly project making a terrible input device. You select a letter by rotating right and left moving down a tree, and press to type it.
==image:"/media/rotary_kb.png":"a breadboard circuit with a rotary encoder"

# jam games
LD is the [Ludum Dare game jam](https://ldjam.com/), where you have 3 days to create a game fitting to a theme that is revealed when the jam starts.

All the below games except for `LD45: Mind the Gap` I made together with [Erikbot](https://github.com/ErikBot42). I have done both art and programming for all of them.

### LD50: Pixel Entropy
`2022-04`
[crispypin.itch.io/ld-50](https://crispypin.itch.io/ld-50)
[github.com/CrispyPin/ld-50](https://github.com/CrispyPin/ld-50)
==image:"/media/jam-games/pixel_entropy.png":"a 2D pixel physics sandbox"

### LD49: Shork Inc
`2021-09`
[crispypin.itch.io/ld-49](https://crispypin.itch.io/ld-49)
[github.com/CrispyPin/ld-49](https://github.com/CrispyPin/ld-49)
==image:"/media/jam-games/shork_inc.png":"a messy low-poly warehouse scene"

### LD48: Shork
`2021-04`
[crispypin.itch.io/ld-48](https://crispypin.itch.io/ld-48)
[github.com/CrispyPin/ld-48](https://github.com/CrispyPin/ld-48)

### LD47: Dynamic Flux Entropy
`2020-10`
[crispypin.itch.io/ld-47](https://crispypin.itch.io/ld-47)
[github.com/CrispyPin/ld-47](https://github.com/CrispyPin/ld-47)

### LD46: Tree Shroomulator
`2020-04`
[crispypin.itch.io/ld-46](https://crispypin.itch.io/ld-46)

### LD45: Mind the Gap
`2019-10`
[crispypin.itch.io/ld-45](https://crispypin.itch.io/ld-45)

### Blackthornprod gamejam 2: Starship: Conquer Space
`2019-04`
[crispypin.itch.io/starship-conquer-space](https://crispypin.itch.io/starship-conquer-space)
==image:"/media/jam-games/starship.png":"some machines on the surface of a tiny planet, with a cosmonaut in the center"

### LD43: The robot's adventure
`2018-12`
[crispypin.itch.io/ld-43](https://crispypin.itch.io/ld-43)

### LD42: Forklift Simulator
`2018-08`
[crispypin.itch.io/ld-42](https://crispypin.itch.io/ld-42)
==image:"/media/jam-games/forklift_simulator.png":"top-down view of a forklift surrounded by boxes in different colours"

# shaders
Most of my shaders are made in Unity and uploaded as props for ChilloutVR. All my ChilloutVR props are in [this repository](https://git.crispypin.cc/CrispyPin/cvr-props).

### void sphere
`2024-09`
My first time making a vertex shader, it generally works on any simple mesh.
==video:"/media/shaders/void_sphere.mp4"

### hilbert worms
`2024-09`
Little worms following the hilbert curve
==video:"/media/shaders/hilbert_worms.mp4":"bright pink pixel worms":loop=true

### partial QR code
`2024-08`
A shader that can display qr codes of any size, though it requires computing the error correction codes beforehand. Partially because it would be slow to do for every pixel every frame, but mostly because I couldn't find a resource explaining how to do it.
==video:"/media/shaders/qr_shader_bit_order.mp4"

(I used [https://www.nayuki.io/page/creating-a-qr-code-step-by-step](https://www.nayuki.io/page/creating-a-qr-code-step-by-step) as a reference, though the algorithm is very different because I'm using a shader)

### shader quine
`2024-08`
A [quine](https://en.wikipedia.org/wiki/Self-reproducing_program) is a program that outputs its own source code. Since shaders don't have text or file outputs, a shader quine must render its own source code instead. This shader contains the font data required to be readable.
<a href="/media/shaders/shader_quine_198x99.png">
==image:"/media/shaders/shader_quine_198x99.png":"(click for full resolution) A large square of shader code, being rendered by itself"
</a>

### shader quine golf
`2024-08`
Code golf is the art of shortening a program as much as possible while still producing a required behavior. I made a tiny version of the quine, only 2877 bytes large. At the end it does render some random characters, but I still consider it valid. When code golfing, undefined behaviour is part of the fun.
==image:"/media/shaders/shader_quine_2877.png":"a smaller wall of text, with a low-resolution font that is just barely readable"

### sunset
`2023-02`
This is a single fragment shader, which means you can put it on any mesh and it will look the same.
==image:"/media/shaders/sunset_shader.png":"sunset over a calm ocean, with stars visible in the purple sky"

### julia fractal
`2023-07`
They are both animated slowly, but the second one has distortion based on world position.
==image:"/media/shaders/julia.png":"bright purple julia fractal"
==image:"/media/shaders/julia_distorted.png":"bright purple julia fractal, with distortion"

## andriod
`2024-05`
source: [git.crispypin.cc/CrispyPin/android-shaders](https://git.crispypin.cc/CrispyPin/android-shaders)
Using the app [Shader Editor](https://f-droid.org/en/packages/de.markusfisch.android.shadereditor/), I made some shaders for my phone's wallpaper.

### binary clock variants
`2024-05`
The 4x4 version divides the day into 2^16 sections, each one about 1.3s long, and displays the number of sections passed since midnight as a binary number.
==image:"/media/shaders/binary_clock_square.png":"a 4x4 grid of circles, some of which are filled"

This 3-row version uses the traditional division of hours, minutes and seconds, just displaying the three numbers in binary.
==image:"/media/shaders/binary_clock.png":"3 rows of 5, 6 and 6 circles"

## raymarching
### libgarbage
`2023-07`
libgarbage is my raymarching shader library, with which all the following shaders are made with. It doesn't have its own repository right now, but can be found in [git.crispypin.cc/CrispyPin/cvr-props](https://git.crispypin.cc/CrispyPin/cvr-props/src/branch/main/Assets/raymarched/lib)

### libgarbage demo
`2023-09`
An example scene made for libgarbage, showing most of the primitive shapes available.
==video:"/media/shaders/rm_demo_scene.mp4":"a collection of sdf primitives with a reflective material"

### spinny thing
`2023-07`
==video:"/media/shaders/rm_spinny_thing.mp4"

### flesh cube
`2023-07`
==video:"/media/shaders/rm_flesh_cube.mp4":"disgusting pulsating fleshy cube"

### big nut
`2023-09`
I am very mature.
==video:"/media/shaders/rm_big_nut.mp4":"a spinning metallic bolt and nut continually screwing and unscrewing itself"

### loops
`2024-08`
==video:"/media/shaders/rm_looping_loops.mp4":"11 rectangular frames moving through each other smoothly":loop=true

### boxes
`2024-08`
==video:"/media/shaders/rm_boxes.mp4"

## cellular automata
### game of life
`2023-07`
I also made a web version of this in may 2021, see [gol.crispypin.cc](https://gol.crispypin.cc/?cellsize=10&time=2) or [github.com/CrispyPin/gol-wallpaper](https://github.com/CrispyPin/gol-wallpaper) for the source
==image:"/media/shaders/game_of_life.png":"Conway's game of life"

### rule 110
`2023-09`
See [Elementary cellular automaton (Wikipedia)](https://en.wikipedia.org/wiki/Elementary_cellular_automaton).
==image:"/media/shaders/rule_110.png":"elementary cellular automata 110"

### WireWorld
### Lenia/smoothlife
## godot
### voxel raymarcher
# utilities
These programs are less flashy and were made out of necessity. I don't expect anyone else to want to use them, but they are available if that was the case.

### snoud
`2023-02`
source: [https://git.crispypin.cc/CrispyPin/snoud](https://git.crispypin.cc/CrispyPin/snoud)
A simple terminal app that plays multiple audio files on loop, meant for background ambience. I use it for rain and wind sound and have it auto-start when I log in.
==image:"/media/snoud.png"
### htmd
`2024-09`
source: [https://git.crispypin.cc/CrispyPin/htmd](https://git.crispypin.cc/CrispyPin/htmd)
This is the markdown to html generator that this site is built with. It uses markdown as a base but is far from standard markdown, it has weird quirks and macros that I needed.

### webserver
`2024-07`
source: [https://git.crispypin.cc/CrispyPin/webserver](https://git.crispypin.cc/CrispyPin/webserver)
Made at first to learn, then to run this website. It seves files and supports partial requests, allowing you to watch videos without needing the whole file to be cached first. (videos are still partially broken, only some formats work properly)

### julia fractal renderer
`2023-07`
source: [https://git.crispypin.cc/CrispyPin/julia-fractal-renderer](https://git.crispypin.cc/CrispyPin/julia-fractal-renderer)
I used this to generate the image printed on my deskmat, seen in [the picture of my keyboard](#leko-pona)
(see source repo for more examples)
==image:"/media/julia_brain_coral.png"
==image:"/media/julia_renderer_gui.png"

### brainfuck debugger
`2023-12`
source: [https://git.crispypin.cc/CrispyPin/bf-debugger](https://git.crispypin.cc/CrispyPin/bf-debugger)
When I was solving some [Advent of Code](https://adventofcode.com/2023) problems in [Brainfuck](https://esolangs.org/wiki/Brainfuck), I found myself missing the ability to set breakpoints and step a number of iterations through the program, so I made an interactive brainfuck debugger.
==image:"/media/bf_debugger.png"

I used this to develop solutions for part one of day 1 and 4, in advent of code 2023. These can be found here: [https://git.crispypin.cc/CrispyPin/aoc-2023/src/branch/main/bf](https://git.crispypin.cc/CrispyPin/aoc-2023/src/branch/main/bf)

### text editor lili
`2023-03`
source: [https://git.crispypin.cc/CrispyPin/lili](https://git.crispypin.cc/CrispyPin/lili)
`lili` is a terminal text editor that can keep multiple files open. It is far from perfect, it doesn't handle soft linebreaks well and lacks undo/redo. But wider characters at least work (tabs and emoji).
==image:"/media/lili_file_list.png"

### compiler-timer
`2024-01`
source: [https://git.crispypin.cc/crispyPin/compiler-timer](https://git.crispypin.cc/crispyPin/compiler-timer)
At work, I was frustrated by 20-45 minute C++ compile times, so I made a compiler wrapper that keeps track of build times, and tells me the average time wasted per day.

Example output
```
(regular compiler output)

Build took 18.025s
Total wasted today: 44m 5s
5 day average: 35m 38s
Overall average: 40m 22s
Since 2023-09-07: 55h 11m 22s
```

### GDVK godot virtual system input
## SteamVR
### OVR Utils
### sinpin-vr
### steamvr_status
# misc
### snad
### worm lang
### asetniop emulator for x11
### june
### neuralblender-mc
`2021-09`
[https://github.com/crispypin/neuralblender-mc](https://github.com/crispypin/neuralblender-mc)
This was before the "AI" hype bubble became as obnoxious as it is now. I found the website neuralblender.com (no they don't deserve a hyperlink), which generated quite terrible images from a text prompt. There was no information about the website anywhere.
I made a stupid input-emulating script that ran in a vm and generated textures for every texture in minecraft 1.17.

The cursed flowers in the picture below are poppies, which for some reason resulted in a blue-haired cryptid in the corner.
==image:"/media/neuralblender_minecraft.png":"minecraft with very weird textures. Poppy flowers are cursed"

### minesweeper-rs
### rust-mandelbrot
### voxel engine in godot c++
### CounterBot
### godot multiplayer voxel game demo (school project)
